## RevolutionDCM Options Tab
##
## Tab to configure all RevolutionDCM options.
##
## Copyright (c) 2007-2008 The BUG Mod.
##
## Author: Glider1

from CvPythonExtensions import *
import BugOptionsTab
gc = CyGlobalContext()

class RevDCMOptionsTab(BugOptionsTab.BugOptionsTab):

	def __init__(self, screen):
		BugOptionsTab.BugOptionsTab.__init__(self, "RevDCM", "RevDCM")

	def create(self, screen):
		game = gc.getGame()
		networkGame =  game.isGameMultiPlayer()
		tab = self.createTab(screen)
		panel = self.createMainPanel(screen)
		column = self.addOneColumnLayout(screen, panel)
		left, right = self.addTwoColumnLayout(screen, column, "Options", False)
	
		if not networkGame:
			#Interface options
			interfaceOptionsTitle = "Interface Options:"
			#localText.changeTextColor (generalOptionsTitle, gc.getInfoTypeForString("Blue"))
			self.addLabel(screen, left, "RevDCM__RevDCMInterfaceOptions", interfaceOptionsTitle)
			col1, col2, col3, col4 = self.addMultiColumnLayout(screen, right, 4, "HiddenAttitude")
			self.addCheckbox(screen, col1, "RevDCM__RevDCMHiddenAttitude")
			self.addCheckbox(screen, col2, "RevDCM__DYNAMIC_CIV_NAMES")

			screen.attachHSeparator(left, left + "SepInterface1")
			screen.attachHSeparator(right, right + "SepInterface2")

			#DCM options
			self.addLabel(screen, left, "RevDCM__RevDCM_seige", "Siege Options:")
			col1, col2, col3 = self.addMultiColumnLayout(screen, right, 3, "DCM_Seige_Events")
			self.addCheckbox(screen, col1, "RevDCM__DCM_RANGE_BOMBARD")
			self.addCheckbox(screen, col2, "RevDCM__DCM_OPP_FIRE")
			self.addLabel(screen, left, "RevDCM__RevDCM_general", "Battle Options:")
			col1, col2, col3, col4 = self.addMultiColumnLayout(screen, right, 4, "DCM_Events")
			self.addCheckbox(screen, col1, "RevDCM__DCM_BATTLE_EFFECTS")
			self.addCheckbox(screen, col2, "RevDCM__DCM_ARCHER_BOMBARD")
			if(game.isDebugMode()):
				self.addCheckbox(screen, col3, "RevDCM__DCM_STACK_ATTACK")
				self.addCheckbox(screen, col4, "RevDCM__DCM_ATTACK_SUPPORT")
			self.addLabel(screen, left, "RevDCM__RevDCM_air", "Airforce Options:")
			col1, col2, col3 = self.addMultiColumnLayout(screen, right, 3, "DCM_Air_Events")
			self.addCheckbox(screen, col1, "RevDCM__DCM_ACTIVE_DEFENSE")
			self.addCheckbox(screen, col2, "RevDCM__DCM_FIGHTER_ENGAGE")
			self.addCheckbox(screen, col3, "RevDCM__DCM_AIR_BOMBING")

			screen.attachHSeparator(left, left + "SepDCM1")
			screen.attachHSeparator(right, right + "SepDCM2")

			#IDW options
			self.addLabel(screen, left, "RevDCM__RevDCMIDW", "IDW Options:")
			col1, col2, col3 = self.addMultiColumnLayout(screen, right, 3, "IDW_Events1")
			self.addCheckbox(screen, col1, "RevDCM__IDW_ENABLED")
			self.addCheckbox(screen, col2, "RevDCM__IDW_EMERGENCY_DRAFT_ENABLED")
			self.addLabel(screen, left, "RevDCM__RevDCMIDWINFLUENCE", "Influence Options:")
			col1, col2, col3 = self.addMultiColumnLayout(screen, right, 3, "IDW_Events2")
			self.addCheckbox(screen, col1, "RevDCM__IDW_PILLAGE_INFLUENCE_ENABLED")
			self.addCheckbox(screen, col2, "RevDCM__IDW_NO_NAVAL_INFLUENCE")
			self.addCheckbox(screen, col3, "RevDCM__IDW_NO_BARBARIAN_INFLUENCE")

			screen.attachHSeparator(left, left + "SepIDW1")
			screen.attachHSeparator(right, right + "SepIDW2")

			#Super Spies options
			if (not game.isOption(GameOptionTypes.GAMEOPTION_NO_ESPIONAGE)):
				self.addLabel(screen, left, "RevDCM__RevDCMSS", "Spy Options:")
				col1, col2, col3 = self.addMultiColumnLayout(screen, right, 3, "SS_Events1")
				self.addCheckbox(screen, col1, "RevDCM__SS_ENABLED")
				self.addCheckbox(screen, col2, "RevDCM__SS_BRIBE")
				self.addCheckbox(screen, col3, "RevDCM__SS_ASSASSINATE")

			screen.attachHSeparator(left, left + "SepInq1")
			screen.attachHSeparator(right, right + "SepInq2")

			#Inquisitions options
			if (not game.isOption(GameOptionTypes.GAMEOPTION_NO_INQUISITIONS)):
				self.addLabel(screen, left, "RevDCM__RevDCMINQ", "Inquisitions Options:")
				col1, col2, col3 = self.addMultiColumnLayout(screen, right, 3, "INQ_Events1")
				self.addCheckbox(screen, col2, "RevDCM__OC_RESPAWN_HOLY_CITIES")
			
				screen.attachHSeparator(left, left + "SepRel1")
				screen.attachHSeparator(right, right + "SepRel2")

			#General options
			generalOptionsTitle = "General Options:"
			#localText.changeTextColor (generalOptionsTitle, gc.getInfoTypeForString("Blue"))
			self.addLabel(screen, left, "RevDCM__RevDCMGeneralOptions", generalOptionsTitle)
			col1, col2, col3, col4 = self.addMultiColumnLayout(screen, right, 4, "General_Events")
			self.addCheckbox(screen, col1, "RevDCM__RevDCMReset")

			screen.attachHSeparator(left, left + "SepGeneral1")
			screen.attachHSeparator(right, right + "SepGeneral2")
			
			
		else:
			self.addLabel(screen, left, "RevDCM_network_game", "NETWORK GAME DETECTED:")
			self.addLabel(screen, right, "RevDCM_network_game1", "Customising options during network play causes many problems. Options as they stand now must be agreed to between all network players before game start and settled in GlobalDefinesAlt.xml and RevolutionDCM.ini")
			
		
		#On screen information
		self.addLabel(screen, left, "RevDCM_info", "Notes:")
		self.addLabel(screen, right, "RevDCM_info1", "This options screen covers the basic RevolutionDCM options only. \nMore detailed configuration options exist in the file: /MODS/RevolutionDCM/Assets/XML/GlobalDefinesAlt.xml")
		self.addLabel(screen, right, "RevDCM_info2", "The default options are stable and produce well balanced games. Non-default options may introduce reliability issues or may be unbalanced.")
		self.addLabel(screen, right, "RevolutionDCMHelp", "Help documentation found at MODS/RevolutionDCM/docs/")
	